
function y = betacfj(a, b, x)
% PURPOSE: betacf function, a continued fraction representation
%   of the elements of x used in evaluating the incomplete Beta function
%   (betaij.m)
% USAGE: y = betacfj(a,b,x)

% written by:
% James P. LeSage, Dept of Economics
% University of Toledo
% 2801 W. Bancroft St,
% Toledo, OH 43606
% jpl@jpl.econ.utoledo.edu

    bl = 1.0; al = 1.0; ac = 1.0;
 bc=1-(a+b)*x/(1+a);
 for m=1:100;
  aold   = ac;
  fm     = m;
  am     = a+fm;
  atwom  = am+fm;
  xovera = x/atwom;
  d      = fm * (b-fm) * xovera/ (atwom-1);
  al     = ac+d*al;
  bl     = bc+d*bl;
  d      = am * (am+b) * xovera / (atwom+1);
  ac     = al-d*ac;
  bc     = bl-d*bc;
  al     = al/ bc;
  bl     = bl/ bc;
  ac     = ac/ bc;
  bc     = 1;
  if (abs(ac-aold) < eps * abs(ac) | m == 100)
  y=ac;
  break;
  end;
 end;
