function y = betai(a, b, x)
% PURPOSE: Incomplete Beta function
%          (allows for x==0, x==1 cases that arise
%           unlike the MATLAB function betainc)

% written by:
% James P. LeSage, Dept of Economics
% University of Toledo
% 2801 W. Bancroft St,
% Toledo, OH 43606
% jpl@jpl.econ.utoledo.edu

if nargin ~= 3; error('Wrong # of arguments to betai'); end;

 if (x == 0 | x == 1)
  factor=0;
 else
  factor=exp(gammlnj(a+b)-gammlnj(a)-gammlnj(b)+a*log(x)+b*log(1.0-x));
 end;
 if (x < (a+1.0)/(a+b+2.0))
  y =  factor*betacfj(a,b, x )/a;
 else
  y = 1 - factor*betacfj(b,a,1-x)/b;
    end;
