function gln = gammlnj( x)
% PURPOSE: computes the loggamma function.
% USAGE: y = gammlnj(x), is log(gamma(x)), but
%            avoids underflow, overflow
% SEE ALSO: gamma()

% written by:
% James P. LeSage, Dept of Economics
% University of Toledo
% 2801 W. Bancroft St,
% Toledo, OH 43606
% jpl@jpl.econ.utoledo.edu

    cof = zeros(6);
    cof = [76.18009173 
          -86.50532033
          24.01409822
          -1.231739516
       0.1200858003e-2
       -0.536382e-5];
       
 y = 1; xx = x;

 for i = 1:6; 
  y = y + cof(i)/xx;
  xx = xx + 1;
 end;
 temp = x+4.5;
 gln = log(2.506628274652)+log(y)+(x-.5)*log(temp)-temp;
