function [PP,QQ,RR,SS]=harald(AA,BB,CC,DD,FF,GG,HH,JJ,KK,LL,MM,NN,PP);

%%%%% This function takes the PP matrix computed by "deterministicdynamics.m"
%		and computes the remaining QQ,RR,SS matrices from Harald Uhlig's code

[l_equ,m_states] = size(AA);
[l_equ,n_endog ] = size(CC);
k_exog = min(size(NN));

CC_plus = pinv(CC);
CC_0 = (null(CC'))';
    
    
RR = - CC_plus*(AA*PP+BB);
VV = [ kron(eye(k_exog),AA),   kron(eye(k_exog),CC)
       kron(NN',FF)+kron(eye(k_exog),(FF*PP+JJ*RR+GG)), ...
       kron(NN',JJ)+kron(eye(k_exog),KK) ];
                               
 

 
LLNN_plus_MM = LL*NN + MM;
QQSS_vec = - VV \ [ DD(:)
                    LLNN_plus_MM(:) ];
                         
QQ = reshape(QQSS_vec(1:m_states*k_exog),m_states,k_exog);
SS = reshape(QQSS_vec((m_states*k_exog+1):((m_states+n_endog)*k_exog)),n_endog,k_exog);
WW = [ eye(m_states)         , zeros(m_states,k_exog)
       RR*pinv(PP)           , (SS-RR*pinv(PP)*QQ) 
       zeros(k_exog,m_states), eye(k_exog)            ];
        

