function [XX,YY,ZZ]=impulse_response(NN,PP,QQ,RR,SS,shock,H,N)

%%%%% Set up horizon

XX=zeros(N-1,H+2);
YY=zeros(N+1,H+2);
ZZ=zeros(3,H+2);

%%%%% Iterate on laws of motion

ZZ(:,1)=zeros(3,1);
ZZ(:,2)=shock;

XX(:,1)=zeros(N-1,1);
XX(:,2)=PP*XX(:,1)+QQ*shock;

YY(:,1)=zeros(N+1,1);
YY(:,2)=RR*XX(:,1)+SS*shock;

for h=1:H,
   ZZ(:,2+h)=NN*ZZ(:,1+h);
   XX(:,2+h)=PP*XX(:,1+h)+QQ*ZZ(:,2+h);
   YY(:,2+h)=RR*XX(:,1+h)+SS*ZZ(:,2+h);
end




